#ifdef ATL_UCLEANN
#define ATL_sJIK80x0x80TN80x80x0_a1_b0 ATL_sgpNBmm_b0
#else
#define ATL_sJIK80x0x80TN80x80x0_a1_b0 ATL_spNBmm_b0
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK2x0x80TN2x1x1_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=2, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *stM = A + 160;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(2*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 80, incAn = -160;
   #define incBk 1
   const int incBm = -80, incBn = 80;
   #define incCm 2
   const int incCn = (ldc) - 2;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0;
   register float rC0_0, rC1_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      ATL_pfl1W(pC0);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[80];
      rC0_0 = rA0 * rB0;
      rC1_0 = rA1 * rB0;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=79; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[80];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK80x0x80TN3x1x1_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=3, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 6240;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*1)/(80*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 160, incAn = -6240;
   #define incBk 1
   const int incBm = -80, incBn = 80;
   #define incCm 3
   const int incCn = (ldc) - 78;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[80];
         rA2 = pA0[160];
         rC0_0 = rA0 * rB0;
         rC1_0 = rA1 * rB0;
         rC2_0 = rA2 * rB0;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=79; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[80];
            rA2 = pA0[160];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK2x0x80TN2x1x1_a1_b0(2, N, 80, alpha, ca + 6240, lda, cb, ldb, beta, cc + 78, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK2x0x80TN2x8x1_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=2, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N>>3)<<3;
   const float *stM = A + 160;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*8)/(2*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 80, incAn = -160;
   #define incBk 1
   const int incBm = -80, incBn = 640;
   #define incCm 2
   const int incCn = (((ldc) << 3)) - 2;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5, rC0_6, rC1_6, rC0_7, rC1_7;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      rC0_3 = *pC3;
      rC0_4 = *pC4;
      rC0_5 = *pC5;
      rC0_6 = *pC6;
      rC0_7 = *pC7;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      ATL_pfl1W(pC4);
      ATL_pfl1W(pC5);
      ATL_pfl1W(pC6);
      ATL_pfl1W(pC7);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[80];
      rB1 = pB0[80];
      rB2 = pB0[160];
      rB3 = pB0[240];
      rB4 = pB0[320];
      rB5 = pB0[400];
      rC0_0 = rA0 * rB0;
      rB6 = pB0[480];
      rC1_0 = rA1 * rB0;
      rB7 = pB0[560];
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rC0_4 = rA0 * rB4;
      rC1_4 = rA1 * rB4;
      rC0_5 = rA0 * rB5;
      rC1_5 = rA1 * rB5;
      rC0_6 = rA0 * rB6;
      rC1_6 = rA1 * rB6;
      rC0_7 = rA0 * rB7;
      rC1_7 = rA1 * rB7;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=79; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[80];
         rB1 = pB0[80];
         rB2 = pB0[160];
         rB3 = pB0[240];
         rB4 = pB0[320];
         rB5 = pB0[400];
         rC0_0 += rA0 * rB0;
         rB6 = pB0[480];
         rC1_0 += rA1 * rB0;
         rB7 = pB0[560];
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rC0_6 += rA0 * rB6;
         rC1_6 += rA1 * rB6;
         rC0_7 += rA0 * rB7;
         rC1_7 += rA1 * rB7;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      *pC4 = rC0_4;
      pC4[1] = rC1_4;
      *pC5 = rC0_5;
      pC5[1] = rC1_5;
      *pC6 = rC0_6;
      pC6[1] = rC1_6;
      *pC7 = rC0_7;
      pC7[1] = rC1_7;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pC6 += incCm;
      pC7 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK80x0x80TN80x80x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=3, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N>>3)<<3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 6240;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*8)/(80*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 160, incAn = -6240;
   #define incBk 1
   const int incBm = -80, incBn = 640;
   #define incCm 3
   const int incCn = (((ldc) << 3)) - 78;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3, rC0_4, rC1_4, rC2_4, rC0_5, rC1_5, rC2_5, rC0_6, rC1_6, rC2_6, rC0_7, rC1_7, rC2_7;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
/*
 *          Feeble prefetch of C
 */
            rC0_0 = *pC0;
            rC0_1 = *pC1;
            rC0_2 = *pC2;
            rC0_3 = *pC3;
            rC0_4 = *pC4;
            rC0_5 = *pC5;
            rC0_6 = *pC6;
            rC0_7 = *pC7;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
            ATL_pfl1W(pC3);
            ATL_pfl1W(pC4);
            ATL_pfl1W(pC5);
            ATL_pfl1W(pC6);
            ATL_pfl1W(pC7);
/*
 *          Peel 1st iter to assign C regs
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[80];
            rA2 = pA0[160];
            rB1 = pB0[80];
            rB2 = pB0[160];
            rB3 = pB0[240];
            rB4 = pB0[320];
            rC0_0 = rA0 * rB0;
            rB5 = pB0[400];
            rC1_0 = rA1 * rB0;
            rB6 = pB0[480];
            rC2_0 = rA2 * rB0;
            rB7 = pB0[560];
            rC0_1 = rA0 * rB1;
            rC1_1 = rA1 * rB1;
            rC2_1 = rA2 * rB1;
            rC0_2 = rA0 * rB2;
            rC1_2 = rA1 * rB2;
            rC2_2 = rA2 * rB2;
            rC0_3 = rA0 * rB3;
            rC1_3 = rA1 * rB3;
            rC2_3 = rA2 * rB3;
            rC0_4 = rA0 * rB4;
            rC1_4 = rA1 * rB4;
            rC2_4 = rA2 * rB4;
            rC0_5 = rA0 * rB5;
            rC1_5 = rA1 * rB5;
            rC2_5 = rA2 * rB5;
            rC0_6 = rA0 * rB6;
            rC1_6 = rA1 * rB6;
            rC2_6 = rA2 * rB6;
            rC0_7 = rA0 * rB7;
            rC1_7 = rA1 * rB7;
            rC2_7 = rA2 * rB7;
            pA0 += incAk;
            pB0 += incBk;
/*
 *          Unpeeled K iterations
 */
            for (k=79; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[80];
               rA2 = pA0[160];
               rB1 = pB0[80];
               rB2 = pB0[160];
               rB3 = pB0[240];
               rB4 = pB0[320];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[400];
               rC1_0 += rA1 * rB0;
               rB6 = pB0[480];
               rC2_0 += rA2 * rB0;
               rB7 = pB0[560];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rC2_4 += rA2 * rB4;
               rC0_5 += rA0 * rB5;
               rC1_5 += rA1 * rB5;
               rC2_5 += rA2 * rB5;
               rC0_6 += rA0 * rB6;
               rC1_6 += rA1 * rB6;
               rC2_6 += rA2 * rB6;
               rC0_7 += rA0 * rB7;
               rC1_7 += rA1 * rB7;
               rC2_7 += rA2 * rB7;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            *pC3 = rC0_3;
            pC3[1] = rC1_3;
            pC3[2] = rC2_3;
            *pC4 = rC0_4;
            pC4[1] = rC1_4;
            pC4[2] = rC2_4;
            *pC5 = rC0_5;
            pC5[1] = rC1_5;
            pC5[2] = rC2_5;
            *pC6 = rC0_6;
            pC6[1] = rC1_6;
            pC6[2] = rC2_6;
            *pC7 = rC0_7;
            pC7[1] = rC1_7;
            pC7[2] = rC2_7;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK80x0x80TN3x1x1_a1_b0(80, k, 80, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 4)), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb)

      ATL_sJIK2x0x80TN2x8x1_a1_b0(2, Nb, 80, alpha, ca + 6240, lda, cb, ldb, beta, cc + 78, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
