#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x0TN1x1x1_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const double *stM = A + (lda*Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK0x0x0TN8x1x1_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=8, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>3)<<3;
   #define Nb N
   #define Kb K
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((((lda) << 3)) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 8
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            for (k=K; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rA6 = *pA6;
               rA7 = *pA7;
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pA4 += incAk;
               pA5 += incAk;
               pA6 += incAk;
               pA7 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pA4 += incAm;
            pA5 += incAm;
            pA6 += incAm;
            pA7 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pA4 += incAn;
         pA5 += incAn;
         pA6 += incAn;
         pA7 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x0TN1x1x1_a1_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x0TN1x4x1_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N>>2)<<2;
   #define Kb K
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (((ldb) << 2));
   #define incCm 1
   const int incCn = (((ldc) << 2)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC0_1, rC0_2, rC0_3;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            for (k=K; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rB3 = *pB3;
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               pA0 += incAk;
               pB0 += incBk;
               pB1 += incBk;
               pB2 += incBk;
               pB3 += incBk;
            }
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
            pB2 += incBm;
            pB3 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
         pB2 += incBn;
         pB3 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK0x0x0TN1x1x1_a1_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x0TN0x0x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=8, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>3)<<3;
   const int Nb = (N>>2)<<2;
   #define Kb K
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((((lda) << 3)) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (((ldb) << 2));
   #define incCm 8
   const int incCn = (((ldc) << 2)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC7_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC7_3;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+16);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC4_0 = pC0[4];
               rC4_0 *= rA0;
               rC5_0 = pC0[5];
               rC5_0 *= rA0;
               rC6_0 = pC0[6];
               rC6_0 *= rA0;
               rC7_0 = pC0[7];
               rC7_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
               rC4_1 = pC1[4];
               rC4_1 *= rA0;
               rC5_1 = pC1[5];
               rC5_1 *= rA0;
               rC6_1 = pC1[6];
               rC6_1 *= rA0;
               rC7_1 = pC1[7];
               rC7_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[1];
               rC1_2 *= rA0;
               rC2_2 = pC2[2];
               rC2_2 *= rA0;
               rC3_2 = pC2[3];
               rC3_2 *= rA0;
               rC4_2 = pC2[4];
               rC4_2 *= rA0;
               rC5_2 = pC2[5];
               rC5_2 *= rA0;
               rC6_2 = pC2[6];
               rC6_2 *= rA0;
               rC7_2 = pC2[7];
               rC7_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[1];
               rC1_3 *= rA0;
               rC2_3 = pC3[2];
               rC2_3 *= rA0;
               rC3_3 = pC3[3];
               rC3_3 *= rA0;
               rC4_3 = pC3[4];
               rC4_3 *= rA0;
               rC5_3 = pC3[5];
               rC5_3 *= rA0;
               rC6_3 = pC3[6];
               rC6_3 *= rA0;
               rC7_3 = pC3[7];
               rC7_3 *= rA0;
               for (k=K; k; k--) /* easy loop to unroll */
               {
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = *pA1;
                  rA2 = *pA2;
                  rA3 = *pA3;
                  rA4 = *pA4;
                  rA5 = *pA5;
                  rA6 = *pA6;
                  rA7 = *pA7;
                  rB1 = *pB1;
                  rB2 = *pB2;
                  rB3 = *pB3;
                  rC0_0 += rA0 * rB0;
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC6_0 += rA6 * rB0;
                  rC7_0 += rA7 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC6_1 += rA6 * rB1;
                  rC7_1 += rA7 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  rC6_2 += rA6 * rB2;
                  rC7_2 += rA7 * rB2;
                  rC0_3 += rA0 * rB3;
                  rC1_3 += rA1 * rB3;
                  rC2_3 += rA2 * rB3;
                  rC3_3 += rA3 * rB3;
                  rC4_3 += rA4 * rB3;
                  rC5_3 += rA5 * rB3;
                  rC6_3 += rA6 * rB3;
                  rC7_3 += rA7 * rB3;
                  pA0 += incAk;
                  pA1 += incAk;
                  pA2 += incAk;
                  pA3 += incAk;
                  pA4 += incAk;
                  pA5 += incAk;
                  pA6 += incAk;
                  pA7 += incAk;
                  pB0 += incBk;
                  pB1 += incBk;
                  pB2 += incBk;
                  pB3 += incBk;
               }
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               pC0[4] = rC4_0;
               pC0[5] = rC5_0;
               pC0[6] = rC6_0;
               pC0[7] = rC7_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               pC1[4] = rC4_1;
               pC1[5] = rC5_1;
               pC1[6] = rC6_1;
               pC1[7] = rC7_1;
               *pC2 = rC0_2;
               pC2[1] = rC1_2;
               pC2[2] = rC2_2;
               pC2[3] = rC3_2;
               pC2[4] = rC4_2;
               pC2[5] = rC5_2;
               pC2[6] = rC6_2;
               pC2[7] = rC7_2;
               *pC3 = rC0_3;
               pC3[1] = rC1_3;
               pC3[2] = rC2_3;
               pC3[3] = rC3_3;
               pC3[4] = rC4_3;
               pC3[5] = rC5_3;
               pC3[6] = rC6_3;
               pC3[7] = rC7_3;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pA0 += incAm;
               pA1 += incAm;
               pA2 += incAm;
               pA3 += incAm;
               pA4 += incAm;
               pA5 += incAm;
               pA6 += incAm;
               pA7 += incAm;
               pB0 += incBm;
               pB1 += incBm;
               pB2 += incBm;
               pB3 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pA0 += incAn;
            pA1 += incAn;
            pA2 += incAn;
            pA3 += incAn;
            pA4 += incAn;
            pA5 += incAn;
            pA6 += incAn;
            pA7 += incAn;
            pB0 += incBn;
            pB1 += incBn;
            pB2 += incBn;
            pB3 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_dJIK0x0x0TN8x1x1_a1_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_dJIK0x0x0TN1x4x1_a1_bX(k, Nb, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
